#-----------------------------------------------------------------------------
# TripleGraph
# 2/18/04
# Slight modification 5/6/07 for typecasting diff in Python 2.4
# (in 'range' statements, needed to cast Width and Height to int)

# Copyright (c) 2007 David G. Drumright (ockham)
#-----------------------------------------------------------------------------

from Tkinter import *
root=Tk()
import poser
scene = poser.Scene()

#-----------------------------------------------------------------------------
global Part1
global Part2
global Part3
global Parm1
global Parm2
global Parm3
global StartFrame
global EndFrame
global Min1,Min2,Min3
global Max1,Max2,Max3
global UpdateOK
global CursorX
global MouseY1Press
global MouseY2Press
global MouseY3Press
global Yscale1,Yscale2,Yscale3
global Xscale

Part1=0
Part2=0
Part3=0
Parm1=0
Parm2=0
Parm3=0
Min1=0.0
Min2=0.0
Min3=0.0
Max1=0.0
Max2=0.0
Max3=0.0
UpdateOK=1
MouseY1Press=0
MouseY2Press=0
MouseY3Press=0
Yscale1=0.0
Yscale2=0.0
Yscale3=0.0
Xscale=0.0

# Keep these in the 1-based form.  Convert to 0-based just before actual use.
StartFrame = 1
EndFrame = scene.NumFrames()

Height =100.0
Width = 500.0
HalfHeight = Height/2.0
HalfWidth = Width/2.0
CursorX=HalfWidth

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("TripleGraph")
        self.Part1Name=StringVar()
        self.Part2Name=StringVar()
        self.Part3Name=StringVar()
        self.Part1Name.set("No selection")
        self.Part2Name.set("No selection")
        self.Part3Name.set("No selection")

        # Frames
        self.Frame1 = Frame(self.master,borderwidth=2,relief=RIDGE)
        self.Frame1.grid(row=0,column=0,sticky=E+W)
        self.Frame2 = Frame(self.master,borderwidth=2,relief=RIDGE)
        self.Frame2.grid(row=1,column=0,sticky=E+W)
        self.Frame3 = Frame(self.master,borderwidth=2,relief=RIDGE)
        self.Frame3.grid(row=2,column=0,sticky=E+W)
        self.ButtonFrame = Frame(self.master,borderwidth=2,relief=RIDGE)
        self.ButtonFrame.grid(row=3,column=0,sticky=E)

        # Contents of frame 1
        self.Label1=Label(self.Frame1,text="No selection",textvariable=self.Part1Name).grid(row=0,column=1)
        self.Parm1ListScroll = Scrollbar(self.Frame1, orient=VERTICAL)
        self.Parm1ListScroll.grid( row=1, column=0,sticky=N+S+E)
        self.Parm1ListBox = Listbox(self.Frame1, height=5, selectmode=SINGLE,yscrollcommand = self.Parm1ListScroll.set,exportselection=0)
        self.Parm1ListBox.grid( row=1, column=1)
        self.Parm1ListScroll["command"] = self.Parm1ListBox.yview

        self.Max1Entry = Entry(self.Frame1,width=10)
        self.Max1Entry.grid(row=1,column=2,sticky=N)
        self.Connect1Button = Button(self.Frame1,text="Connect",command=self.HandleConnect1)
        self.Connect1Button.grid(row=1,column=2)
        self.Min1Entry = Entry(self.Frame1,width=10)
        self.Min1Entry.grid(row=1,column=2,sticky=S)

        self.Graph1 = Canvas(self.Frame1,bg="white",width=Width,height=Height)
        self.Graph1.grid(row=0, column=3,rowspan=2,sticky=E)

        # Contents of frame 2
        self.Label2=Label(self.Frame2,text="No selection",textvariable=self.Part2Name).grid(row=0,column=1)
        self.Parm2ListScroll = Scrollbar(self.Frame2, orient=VERTICAL)
        self.Parm2ListScroll.grid( row=1, column=0,sticky=N+S+E)
        self.Parm2ListBox = Listbox(self.Frame2, height=5, selectmode=SINGLE,yscrollcommand = self.Parm2ListScroll.set,exportselection=0)
        self.Parm2ListBox.grid( row=1, column=1)
        self.Parm2ListScroll["command"] = self.Parm2ListBox.yview

        self.Max2Entry = Entry(self.Frame2,width=10)
        self.Max2Entry.grid(row=1,column=2,sticky=N)
        self.Connect2Button = Button(self.Frame2,text="Connect",command=self.HandleConnect2)
        self.Connect2Button.grid(row=1,column=2)
        self.Min2Entry = Entry(self.Frame2,width=10)
        self.Min2Entry.grid(row=1,column=2,sticky=S)

        self.Graph2 = Canvas(self.Frame2,bg="white",width=Width,height=Height)
        self.Graph2.grid(row=0, column=3,rowspan=2,sticky=E)

        # Contents of frame 3
        self.Label3=Label(self.Frame3,text="No selection",textvariable=self.Part3Name).grid(row=0,column=1)
        self.Parm3ListScroll = Scrollbar(self.Frame3, orient=VERTICAL)
        self.Parm3ListScroll.grid( row=1, column=0,sticky=N+S+E)
        self.Parm3ListBox = Listbox(self.Frame3, height=5, selectmode=SINGLE,yscrollcommand = self.Parm3ListScroll.set,exportselection=0)
        self.Parm3ListBox.grid( row=1, column=1)
        self.Parm3ListScroll["command"] = self.Parm3ListBox.yview

        self.Max3Entry = Entry(self.Frame3,width=10)
        self.Max3Entry.grid(row=1,column=2,sticky=N)
        self.Connect3Button = Button(self.Frame3,text="Connect",command=self.HandleConnect3)
        self.Connect3Button.grid(row=1,column=2)
        self.Min3Entry = Entry(self.Frame3,width=10)
        self.Min3Entry.grid(row=1,column=2,sticky=S)

        self.Graph3 = Canvas(self.Frame3,bg="white",width=Width,height=Height)
        self.Graph3.grid(row=0, column=3,rowspan=2,sticky=E)

        # Start/End frame

        Label(self.ButtonFrame,text="Start").grid(row=0,column=0)
        self.StartEntry = Entry(self.ButtonFrame,width=6)
        self.StartEntry.grid(row=0,column=1)
        Label(self.ButtonFrame,text="End").grid(row=0,column=2)
        self.EndEntry = Entry(self.ButtonFrame,width=6)
        self.EndEntry.grid(row=0,column=3)
        self.CursorSlider=Scale(self.ButtonFrame, from_=StartFrame, to=EndFrame,orient=HORIZONTAL,length=Width)
        # Initially set to the actual Start and End.  Will rescale each time the S and E are changed.
        self.CursorSlider.grid(row=0, column=6,columnspan=3)
        self.StartEntry.insert(0,str(StartFrame))
        self.EndEntry.insert(0,str(EndFrame))
        self.CursorSlider.set(StartFrame+(EndFrame-StartFrame)/2)

        # Selection bindings
        self.Parm1ListBox.bind("<Double-Button-1>",self.HandleParm1Select)
        self.Parm2ListBox.bind("<Double-Button-1>",self.HandleParm2Select)
        self.Parm3ListBox.bind("<Double-Button-1>",self.HandleParm3Select)
        self.Max1Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.Max2Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.Max3Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.Min1Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.Min2Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.Min3Entry.bind("<KeyPress-Return>",self.HandleEntry)
        self.StartEntry.bind("<KeyPress-Return>",self.HandleEntry)
        self.EndEntry.bind("<KeyPress-Return>",self.HandleEntry)
        self.CursorSlider.bind("<Motion>",self.HandleSliderMove)
        self.CursorSlider.bind("<ButtonRelease-1>",self.HandleSliderStop)
        self.Graph1.bind("<Button-1>",self.HandleMousePress1)
        self.Graph2.bind("<Button-1>",self.HandleMousePress2)
        self.Graph3.bind("<Button-1>",self.HandleMousePress3)
        self.Graph1.bind("<ButtonRelease-1>",self.HandleMouseRelease1)
        self.Graph2.bind("<ButtonRelease-1>",self.HandleMouseRelease2)
        self.Graph3.bind("<ButtonRelease-1>",self.HandleMouseRelease3)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)

        # The Parm Lists are emptied and refilled each time you select
        # a new Part for the same graph.

    # - - - - - - - - - - - - - - - - - -

    def HandleConnect1(self):
        global Part1
        # Clear the list box
        self.Parm1ListBox.delete(0,END)
        # Take whatever is the Current selection and make it the Part.
        Part1 = scene.CurrentActor()
        # Build a name: if the actor is part of a figure, include the fig.
        if Part1.IsBodyPart():
            st = "%s : %s" % (Part1.ItsFigure().Name(), Part1.Name())
        else:
            st = Part1.Name()
        self.Part1Name.set(st)
        for OneParm in Part1.Parameters():
            if not OneParm.Hidden():  # Leave out the joint stuff
                self.Parm1ListBox.insert(END, OneParm.Name())
    # - - - - - - - - - - - - - - - - - -
    def HandleConnect2(self):
        global Part2
        # Clear the list box
        self.Parm2ListBox.delete(0,END)
        # Take whatever is the Current selection and make it the Part.
        Part2 = scene.CurrentActor()
        # Build a name: if the actor is part of a figure, include the fig.
        if Part2.IsBodyPart():
            st = "%s : %s" % (Part2.ItsFigure().Name(), Part2.Name())
        else:
            st = Part2.Name()
        self.Part2Name.set(st)
        for OneParm in Part2.Parameters():
            if not OneParm.Hidden():  # Leave out the joint stuff
                self.Parm2ListBox.insert(END, OneParm.Name())
    # - - - - - - - - - - - - - - - - - -
    def HandleConnect3(self):
        global Part3
        # Clear the list box
        self.Parm3ListBox.delete(0,END)
        # Take whatever is the Current selection and make it the Part.
        Part3 = scene.CurrentActor()
        # Build a name: if the actor is part of a figure, include the fig.
        if Part3.IsBodyPart():
            st = "%s : %s" % (Part3.ItsFigure().Name(), Part3.Name())
        else:
            st = Part3.Name()
        self.Part3Name.set(st)
        for OneParm in Part3.Parameters():
            if not OneParm.Hidden():  # Leave out the joint stuff
                self.Parm3ListBox.insert(END, OneParm.Name())
    # - - - - - - - - - - - - - - - - - -

    def HandleParm1Select(self,event):
        global Parm1
        global Max1,Min1
        if not Part1: return
        # Make the selection, refresh.
        Sels = event.widget.curselection()
        if not Sels: return  # Nothing to do
        Name = event.widget.get(int(Sels[0]))
        Parm1 = Part1.Parameter(Name)
        # Fill in the Max and Min boxes for this parm
        Max1 = Parm1.MaxValue()
        self.Max1Entry.delete(0,END)
        self.Max1Entry.insert(0,str(Max1))
        Min1 = Parm1.MinValue()
        self.Min1Entry.delete(0,END)
        self.Min1Entry.insert(0,str(Min1))
        self.RefreshAll()

    # - - - - - - - - - - - - - - - - - -

    def HandleParm2Select(self,event):
        global Parm2
        global Max2,Min2
        if not Part2: return
        # Make the selection, refresh.
        Sels = event.widget.curselection()
        if not Sels: return  # Nothing to do
        Name = event.widget.get(int(Sels[0]))
        Parm2 = Part2.Parameter(Name)
        # Fill in the Max and Min boxes for this parm
        Max2 = Parm2.MaxValue()
        self.Max2Entry.delete(0,END)
        self.Max2Entry.insert(0,str(Max2))
        Min2 = Parm2.MinValue()
        self.Min2Entry.delete(0,END)
        self.Min2Entry.insert(0,str(Min2))
        self.RefreshAll()

    # - - - - - - - - - - - - - - - - - -
    def HandleParm3Select(self,event):
        global Parm3
        global Max3,Min3
        if not Part3: return
        # Make the selection, refresh.
        Sels = event.widget.curselection()
        if not Sels: return  # Nothing to do
        Name = event.widget.get(int(Sels[0]))
        Parm3 = Part3.Parameter(Name)
        # Fill in the Max and Min boxes for this parm
        Max3 = Parm3.MaxValue()
        self.Max3Entry.delete(0,END)
        self.Max3Entry.insert(0,str(Max3))
        Min3 = Parm3.MinValue()
        self.Min3Entry.delete(0,END)
        self.Min3Entry.insert(0,str(Min3))
        self.RefreshAll()
    # - - - - - - - - - - - - - - - - - -

    def HandleEntry(self,event):
        # Hitting Enter in any of the editboxes leads here.
        global StartFrame
        global EndFrame
        global Min1,Min2,Min3,Max1,Max2,Max3

        s = self.StartEntry.get()
        if s: StartFrame = int(s)
        s = self.EndEntry.get()
        if s: EndFrame = int(s)

        # For the max and min, we actually set the Parm's max and min.
        s = self.Min1Entry.get()
        if s and Parm1:
            Min1 = float(s)
            Parm1.SetMinValue(Min1)

        s = self.Max1Entry.get()
        if s and Parm1:
            Max1 = float(s)
            Parm1.SetMaxValue(Max1)

        s = self.Min2Entry.get()
        if s and Parm2:
            Min2 = float(s)
            Parm2.SetMinValue(Min2)

        s = self.Max2Entry.get()
        if s and Parm2:
            Max2 = float(s)
            Parm2.SetMaxValue(Max2)

        s = self.Min3Entry.get()
        if s and Parm3:
            Min3 = float(s)
            Parm3.SetMinValue(Min3)

        s = self.Max3Entry.get()
        if s and Parm3:
            Max3 = float(s)
            Parm3.SetMaxValue(Max3)

        # Keep both in the 1-based visible form.
        if   StartFrame < 1: StartFrame = 1
        elif StartFrame > scene.NumFrames(): StartFrame = scene.NumFrames()
        if   EndFrame < 1: EndFrame = 1
        elif EndFrame > scene.NumFrames(): EndFrame = scene.NumFrames()

        # In the case where you're changing both, this condition check
        # prevents a bad refresh.  For example, you might be trying
        # to switch from (0,30) to (60,100).  Depending on which change
        # you make first, you can end up with Start < End.
        if StartFrame < EndFrame:
            self.RefreshAll()
        # Force the slider to use the new start and end
        self.CursorSlider.configure(from_=StartFrame, to=EndFrame)
        self.CursorSlider.set((StartFrame+EndFrame)/2) # Center it
        self.CursorSlider.update_idletasks()
        # Redraw the actual cursor.
        self.DrawCursor(1)

    # - - - - - - - - - - - - - - - - - -
    def HandleSliderMove(self,event):
        self.DrawCursor(0)
    # - - - - - - - - - - - - - - - - - -
    def HandleSliderStop(self,event):
        self.RefreshAll()
    # - - - - - - - - - - - - - - - - - -
    def HandleMousePress1(self,event):
        # Mouse moves inside the upper graph: Read the Y of the mouse.
        global MouseY1Press
        MouseY1Press = event.y
    # - - - - - - - - - - - - - - - - - -
    def HandleMouseRelease1(self,event):
        # Mouse moves inside the upper graph: Read the Y of the mouse at end of move.
        # Subtract the beginning Y, and use this to move the actual parameter.
        global MouseY1Press
        if not Parm1: return
        Ydiff = MouseY1Press - event.y
        ValDelta = Ydiff / Yscale1
        FrameX = self.CursorSlider.get()  # This is in Frame form
        RestoreFrame=scene.Frame()
        scene.SetFrame(FrameX)
        Parm1.SetValue(Parm1.Value() + ValDelta)
        scene.SetFrame(RestoreFrame)
        self.RefreshAll()

    # - - - - - - - - - - - - - - - - - -

    def HandleMousePress2(self,event):
        # Mouse moves inside the lower graph: Read the Y of the mouse.
        global MouseY2Press
        MouseY2Press = event.y

    # - - - - - - - - - - - - - - - - - -

    def HandleMouseRelease2(self,event):
        # Mouse moves inside the lower graph: Read the Y of the mouse at end of move.
        # Subtract the beginning Y, and use this to move the actual parameter.
        global MouseY2Press
        if not Parm2: return
        Ydiff = MouseY2Press-event.y
        ValDelta = Ydiff / Yscale2
        FrameX = self.CursorSlider.get()  # This is in Frame form
        RestoreFrame=scene.Frame()
        scene.SetFrame(FrameX)
        Parm2.SetValue(Parm2.Value() + ValDelta)
        scene.SetFrame(RestoreFrame)
        self.RefreshAll()

    # - - - - - - - - - - - - - - - - - -
    def HandleMousePress3(self,event):
        # Mouse moves inside the lower graph: Read the Y of the mouse.
        global MouseY3Press
        MouseY3Press = event.y

    # - - - - - - - - - - - - - - - - - -

    def HandleMouseRelease3(self,event):
        # Mouse moves inside the lower graph: Read the Y of the mouse at end of move.
        # Subtract the beginning Y, and use this to move the actual parameter.
        global MouseY3Press
        if not Parm3: return
        Ydiff = MouseY3Press-event.y
        ValDelta = Ydiff / Yscale3
        FrameX = self.CursorSlider.get()  # This is in Frame form
        RestoreFrame=scene.Frame()
        scene.SetFrame(FrameX)
        Parm3.SetValue(Parm3.Value() + ValDelta)
        scene.SetFrame(RestoreFrame)
        self.RefreshAll()
    # - - - - - - - - - - - - - - - - - -

    def DrawCursor(self,Centered):
        # The Centered arg lets us do an init draw that is always centered,
        # or an update draw that keeps up with the last setting.
        global CursorX
        # First undraw cursor in existing location.
        self.Graph1.create_line(CursorX,0,CursorX,Height,fill="white",width=2)
        self.Graph2.create_line(CursorX,0,CursorX,Height,fill="white",width=2)
        self.Graph3.create_line(CursorX,0,CursorX,Height,fill="white",width=2)

        # Change the X.  If the Centered arg is true, just center it. Otherwise
        # pick up the slider and convert it to X.
        if Centered: CursorX = HalfWidth+1
        else:
            FrameX = self.CursorSlider.get()  # This is in Frame form
            CursorX = 2 + float(FrameX - StartFrame) * Width / float(EndFrame-StartFrame+1) # Convert
        # Draw at new location.
        self.Graph1.create_line(CursorX,0,CursorX,Height,fill="red",width=2)
        self.Graph2.create_line(CursorX,0,CursorX,Height,fill="red",width=2)
        self.Graph3.create_line(CursorX,0,CursorX,Height,fill="red",width=2)
        # For clarity: DrawCursor will be called many times during a slider move;
        # each of those moves will erase old and draw new.  This leaves the
        # real graph "patchy", so we do a full refresh followed by another DrawCursor
        # on mouse-release, which will have the same X before and after.  This final draw
        # will undo the patchiness, while saving time during the move.

    # - - - - - - - - - - - - - - - - - -

    def Refresh1(self):
        global Yscale1 # Need this for the MouseRelease action
        if not Parm1: return
        # Fill with actual values at each keyframe.
        Max=Parm1.MaxValue()
        Min=Parm1.MinValue()
        if Max >  HalfHeight: Max =  HalfHeight
        if Min < -HalfHeight: Min = -HalfHeight

        if Max <= Min: return # Line will be straight anyway

        Yscale1 = Height / (Max-Min)
        LegendX    = -1
        LegendY    = -1
        LegendValue=0.0

        # Clear before drawing
        self.Graph1.delete("all")
        # Draw a simple grid, just for reference.
        for X in range(0,int(Width),20): # draw vert lines
            self.Graph1.create_line(X,1, X,Height, fill="green")
        for Y in range(0,int(Height),20):
            self.Graph1.create_line(1,Y, Width,Y, fill="green")

        OldX = 0
        OldY = HalfHeight
        for F in range((StartFrame-1),(EndFrame-1)):
            scene.SetFrame(F)
            Val = Parm1.Value()
            # Force the vals to be within the arbitrary max/min
            if   Val > Max: Val = Max
            elif Val < Min: Val = Min
            Y = HalfHeight - Val * Yscale1
            X = (F + 1 - StartFrame) * Xscale
            # When X equals CursorX, pin down the Frame and Value
            # for easier use in the Legend.
            if (X >= CursorX) and LegendX < 0:
                # Use init value of X to catch when we pass the cursor
                LegendX=X
                LegendY=Y
                LegendValue=Val
            # Draw in segments from last XY to new XY.
            self.Graph1.create_line(OldX,OldY, X,Y,width=2)
            OldX = X
            OldY = Y

        # Write text near the cursor.
        st=" [ %.3f] " % LegendValue
        if LegendX < HalfWidth: # Cursor in left area, write to right of cursor.
            if LegendY < HalfHeight: # above middle
                self.Graph1.create_text(LegendX,LegendY,anchor=NW,text=st,fill="blue")
            else:
                self.Graph1.create_text(LegendX,LegendY,anchor=SW,text=st,fill="blue")
        else:
            if LegendY < HalfHeight: # above middle
                self.Graph1.create_text(LegendX,LegendY,anchor=NE,text=st,fill="blue")
            else:
                self.Graph1.create_text(LegendX,LegendY,anchor=SE,text=st,fill="blue")


    # - - - - - - - - - - - - - - - - - -

    def Refresh2(self):
        global Yscale2 # Need this for the MouseRelease action
        if not Parm2: return
        # For both graphs, fill with actual values at each keyframe.
        Max=Parm2.MaxValue()
        Min=Parm2.MinValue()
        # Keep the values in screen
        if Max >  HalfHeight: Max =  HalfHeight
        if Min < -HalfHeight: Min = -HalfHeight

        if Max <= Min: return # Line will be straight anyway

        Yscale2 = Height / (Max-Min)
        LegendX    = -1
        LegendY    = -1
        LegendValue=0.0

        # Clear before drawing
        self.Graph2.delete("all")
        # Draw a simple grid, just for reference.
        for X in range(0,int(Width),20): # draw vert lines
            self.Graph2.create_line(X,1, X,Height, fill="green")
        for Y in range(0,int(Height),20):
            self.Graph2.create_line(1,Y, Width,Y, fill="green")
        OldX = 0
        OldY = HalfHeight
        for F in range((StartFrame-1),(EndFrame-1)):
            scene.SetFrame(F)
            Val = Parm2.Value()
            # Force the vals to be within the arbitrary max/min
            if   Val > Max: Val = Max
            elif Val < Min: Val = Min
            Y = HalfHeight - Val * Yscale2
            X = (F + 1 - StartFrame) * Xscale
            # When X equals CursorX, pin down the Frame and Value
            # for easier use in the Legend.
            if (X >= CursorX) and LegendX < 0:
                # Use init value of X to catch when we pass the cursor
                LegendX=X
                LegendY=Y
                LegendValue=Val
            # Draw in segments from last XY to new XY.
            self.Graph2.create_line(OldX,OldY, X,Y,width=2)
            OldX = X
            OldY = Y

        # Write text near the cursor.
        st=" [ %.3f] " % LegendValue
        if LegendX < HalfWidth: # Cursor in left area, write to right of cursor.
            if LegendY < HalfHeight: # above middle
                self.Graph2.create_text(LegendX,LegendY,anchor=NW,text=st,fill="blue")
            else:
                self.Graph2.create_text(LegendX,LegendY,anchor=SW,text=st,fill="blue")
        else:
            if LegendY < HalfHeight: # above middle
                self.Graph2.create_text(LegendX,LegendY,anchor=NE,text=st,fill="blue")
            else:
                self.Graph2.create_text(LegendX,LegendY,anchor=SE,text=st,fill="blue")

    # - - - - - - - - - - - - - - - - - -
    def Refresh3(self):
        global Yscale3 # Need this for the MouseRelease action
        if not Parm3: return
        # For both graphs, fill with actual values at each keyframe.
        Max=Parm3.MaxValue()
        Min=Parm3.MinValue()
        # Keep the values in screen
        if Max >  HalfHeight: Max =  HalfHeight
        if Min < -HalfHeight: Min = -HalfHeight

        if Max <= Min: return # Line will be straight anyway

        Yscale3 = Height / (Max-Min)
        LegendX    = -1
        LegendY    = -1
        LegendValue=0.0

        # Clear before drawing
        self.Graph3.delete("all")
        # Draw a simple grid, just for reference.
        for X in range(0,int(Width),20): # draw vert lines
            self.Graph3.create_line(X,1, X,Height, fill="green")
        for Y in range(0,int(Height),20):
            self.Graph3.create_line(1,Y, Width,Y, fill="green")
        OldX = 0
        OldY = HalfHeight
        for F in range((StartFrame-1),(EndFrame-1)):
            scene.SetFrame(F)
            Val = Parm3.Value()
            # Force the vals to be within the arbitrary max/min
            if   Val > Max: Val = Max
            elif Val < Min: Val = Min
            Y = HalfHeight - Val * Yscale3
            X = (F + 1 - StartFrame) * Xscale
            # When X equals CursorX, pin down the Frame and Value
            # for easier use in the Legend.
            if (X >= CursorX) and LegendX < 0:
                # Use init value of X to catch when we pass the cursor
                LegendX=X
                LegendY=Y
                LegendValue=Val
            # Draw in segments from last XY to new XY.
            self.Graph3.create_line(OldX,OldY, X,Y,width=2)
            OldX = X
            OldY = Y

        # Write text near the cursor.
        st=" [ %.3f] " % LegendValue
        if LegendX < HalfWidth: # Cursor in left area, write to right of cursor.
            if LegendY < HalfHeight: # above middle
                self.Graph3.create_text(LegendX,LegendY,anchor=NW,text=st,fill="blue")
            else:
                self.Graph3.create_text(LegendX,LegendY,anchor=SW,text=st,fill="blue")
        else:
            if LegendY < HalfHeight: # above middle
                self.Graph3.create_text(LegendX,LegendY,anchor=NE,text=st,fill="blue")
            else:
                self.Graph3.create_text(LegendX,LegendY,anchor=SE,text=st,fill="blue")
    # - - - - - - - - - - - - - - - - - -

    def RefreshAll(self):
        global UpdateOK
        global Xscale
        UpdateOK=0
        RestoreFrame = scene.Frame()
        # Figure Xscale once for all graphs.
        Xscale = Width / float(EndFrame - StartFrame + 1)
        self.Refresh1()
        self.Refresh2()
        self.Refresh3()
        self.DrawCursor(0)
        UpdateOK=1
        scene.SetFrame(RestoreFrame)

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if UpdateOK: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
